 -- RingSlingerPlus
 -- 2-RSP_HotPotato.lua
 -- 12.07.2023
 -- Sirexer

rawset(_G, "killerqueentime", cv_explodeplayertimer.value*TICRATE)
rawset(_G, "player_rspbomb", false)
local time_chooseit = 3*TICRATE
local showplayerit_text = 0
local snowplayerwin_text = 0
local rspit = nil
local warningcolor = false
local warningcolortime = 0
//Double score for winner.
local function rsp_doublescore(player)
	for player in players.iterate do
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
			if player == RSP.DATA.winner
				player.score = $ * 2
			end
		end
	end
end
//Choose player and make him IT.
local function RandomPlayerITChoose()
	if player_rspbomb == false
		if time_chooseit > 0
			time_chooseit = $1 - 1
		elseif time_chooseit <= 0
		local prandom = P_RandomRange(1, #RSP.DATA.playertablelive)
			if RSP.DATA.playertablelive[prandom]
			and RSP.DATA.playertablelive[prandom].valid
				player_rspbomb = RSP.DATA.playertablelive[prandom].player
				time_chooseit = 3*TICRATE
				showplayerit_text = 2*TICRATE
			end
		end
	end
end
//Giving score for live players.
local function GiveScoreForLive(player)
	for player in players.iterate do
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
		and player.rspghostplayer != true
			if (leveltime % 35) == 15
				player.score = $ + 1
			end
		end
	end
end
//Colorblink of IT
local function ChangeColorForIt()
	if warningcolortime != 0
		warningcolortime = $ - 1
	end
end

local function ITRemovePlayerIT(player)
	if player_rspbomb != false
	and not player_rspbomb.valid
		player_rspbomb = false
	end
end
//Spectators can't join the game.
addHook("TeamSwitch", function(player, team, spec)
	if gametype == GT_HOTPOTATO
	and RSP.DATA.round_ready == true
	and cv_rspdebug.value == 0
		if (#RSP.DATA.playertable >= 2)
			if spec == true
			return false
			end
		end
	end
end)
//Rules of Damage(nature)
addHook("MobjDamage", function(target, inflictor, source, mo, player)
	if gametype == GT_HOTPOTATO
	and RSP.DATA.round_ready == true
		if source and source.player
			//If IT hit a player, Player becomes an IT.
			if source.player == player_rspbomb
				player_rspbomb = target.player
				source.player.normalspeed = skins[source.player.mo.skin].normalspeed
				source.player.actionspd = skins[source.player.mo.skin].actionspd
				P_DoPlayerPain(target.player)
				S_StartSound(target.player.mo, sfx_altdi1)
				showplayerit_text = 2*TICRATE
				for mobj in mobjs.iterate()
					if mobj.type == MT_RSPHEADHUNT
						P_RemoveMobj(mobj)
					end
				end
				rspit = nil
				return true
			end
			//The non-IT can't hurt other players.
			if target.player != player_rspbomb
				return true
			end
			//The non-IT can hurt player IT.
			if target.player == player_rspbomb
				P_DoPlayerPain(target.player)
				S_StartSound(target.player.mo, sfx_altdi1)
				return true
			end
		end
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	if gametype == GT_HOTPOTATO
	and RSP.DATA.round_ready == true
		//Sounds before new player.
		if player_rspbomb == false and RSP.DATA.winner == false
			if time_chooseit == 3*TICRATE or time_chooseit == 2*TICRATE or time_chooseit == 1*TICRATE
				if not S_IdPlaying(sfx_s3ka7)
					S_StartSound(nil, sfx_s3ka7, player)
				end
			end
		end
		//Local functions.
		if (#RSP.DATA.playertablelive >= 2)
		or cv_rspdebug.value == 1
			RandomPlayerITChoose()
			GiveScoreForLive(player)
			ChangeColorForIt()
			ITRemovePlayerIT(player)
		end
		//Timer for text about IT.
		if showplayerit_text > 0
			showplayerit_text = $ - 1
		end
		//Timer for text about winner.
		if snowplayerwin_text > 0
			snowplayerwin_text = $ - 1
		end
		//Timer of explode the IT.
		if killerqueentime != 0
		and player_rspbomb != false
			killerqueentime = $ - 1
		end
		//If there is a winner, end the match.
		if (#RSP.DATA.playertablelive < 2)
		and RSP.DATA.winner != false
		and snowplayerwin_text == 0
		and cv_rspdebug.value == 0
			rsp_doublescore(player)
			G_ExitLevel()
		end
	end
end)

addHook("PlayerThink", function(player, mo)
	if gametype == GT_HOTPOTATO
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
		and player.rspghostplayer != true
			//Target for IT.
			if rspit == nil
			and player == player_rspbomb
				rspit = P_SpawnMobj(player_rspbomb.mo.x, player_rspbomb.mo.y, player_rspbomb.mo.z + player_rspbomb.mo.height + 24*player_rspbomb.mo.scale, MT_RSPIT)
				rspit = 1
			end
			if player == player_rspbomb
			and player_rspbomb != false
				if player.normalspeed != (skins[player.mo.skin].normalspeed + 16*FRACUNIT) or player.actionspd != (skins[player.mo.skin].actionspd + 16*FRACUNIT)
					player.normalspeed = (skins[player.mo.skin].normalspeed + 16*FRACUNIT)
					player.actionspd = (skins[player.mo.skin].actionspd + 16*FRACUNIT)
				end
				//Expldode the player, if he's IT.
				if killerqueentime == 0
					player_rspbomb = false
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.actionspd = skins[player.mo.skin].actionspd
					A_OldRingExplode(player.mo, MT_EXPLODE)
					showplayerit_text = 0
					P_KillMobj(player.mo)
					player.rspghostplayer = true
					rspit = nil
					killerqueentime = cv_explodeplayertimer.value*TICRATE
				end
				//Colorblink for IT.
				if killerqueentime <= 3*TICRATE
					player.warningcolor = true
					player.mo.colorized = true
					if player.mo.color == SKINCOLOR_CRIMSON
					and warningcolortime == 0
						warningcolortime = 3
						player.mo.color = player.skincolor
					end
					if player.mo.color == player.skincolor
					and warningcolortime == 0
						warningcolortime = 3
						player.mo.color = SKINCOLOR_RED
					end
					if player.mo.color == SKINCOLOR_RED
					and warningcolortime == 0
						warningcolortime = 3
						player.mo.color = SKINCOLOR_CRIMSON
					end
				end
			end
			//If the player exploded, remove the color.
			if player != player_rspbomb
			and player.warningcolor == true
				player.warningcolor = false
				player.mo.colorized = false
				player.mo.color = player.skincolor
			end
			//If the players are alive, the match will start.
			if (#RSP.DATA.playertablelive < 2)
			and RSP.DATA.round_ready == true
			and RSP.DATA.winner == false
			and cv_rspdebug.value == 0
				showplayerit_text = 0
				RSP.DATA.winner = player
				snowplayerwin_text = 3*TICRATE
				RSP.DATA.getready = true
			end
		end
		//If player is dead, becomes a ghost.
		if RSP.DATA.round_ready == true
			if player.mo
			and player.mo.valid
			and player.playerstate == PST_DEAD
				if player == player_rspbomb
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.actionspd = skins[player.mo.skin].actionspd
					player_rspbomb = false
				end
				if player.rspghostplayer != true
					player.rspghostplayer = true
				end
			end
		end
	end
end)
//Teleporting target IT.
addHook("MobjThinker", function(mo)
	if rspit != nil
	and player_rspbomb != false
	and player_rspbomb.valid
		for player in players.iterate do
			if player.mo
			and player.mo.valid
			and player.playerstate == PST_LIVE
				if player == player_rspbomb
					local z = player.mo.z + player.mo.height + 16*FRACUNIT
					P_SetOrigin(mo, player.mo.x, player.mo.y, z)
					return true
				end
			end
		end
	end
	if player_rspbomb == false
		P_RemoveMobj(mo)
		rspit = nil
	end
end, MT_RSPIT)

local function HotPotatoRSP(v, player, cam)
	if gametype == GT_HOTPOTATO
		if player == player_rspbomb 
			v.drawScaled(304*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPLUSIT"), V_SNAPTORIGHT|V_ALLOWLOWERCASE)
		end
		if player_rspbomb == false
		and RSP.DATA.winner == false
		and RSP.DATA.round_ready == true
			if (time_chooseit > 2*TICRATE
			and time_chooseit <= 3*TICRATE)
				v.drawScaled(RSP.hud[player.rsp_hud].gt_message_x*FRACUNIT, RSP.hud[player.rsp_hud].gt_message_y*FRACUNIT, FRACUNIT, v.cachePatch("RACE3"), V_OFFSET)
			end
			if (time_chooseit > 1*TICRATE
			and time_chooseit <= 2*TICRATE)
				v.drawScaled(RSP.hud[player.rsp_hud].gt_message_x*FRACUNIT, RSP.hud[player.rsp_hud].gt_message_y*FRACUNIT, FRACUNIT, v.cachePatch("RACE2"), V_OFFSET)
			end
			if (time_chooseit > 0*TICRATE
			and time_chooseit <= 1*TICRATE)
				v.drawScaled(RSP.hud[player.rsp_hud].gt_message_x*FRACUNIT, RSP.hud[player.rsp_hud].gt_message_y*FRACUNIT, FRACUNIT, v.cachePatch("RACE1"), V_OFFSET)
			end
		end
		if snowplayerwin_text > 0
			if player == RSP.DATA.winner
			and RSP.DATA.winner.valid
				v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, "You're survived!", V_OFFSET, "thin-center")
			else
				v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, RSP.DATA.winner.name.." Is Survived!", V_OFFSET, "thin-center")
			end
		end
		if showplayerit_text > 0
			if player != RSP.DATA.winner
				if player == player_rspbomb
				and player_rspbomb.valid
					v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, "YOU'RE IT!", V_OFFSET, "thin-center")
				else
					v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, player_rspbomb.name.." is IT!", V_OFFSET, "thin-center")
				end
			end
		end
	end
end
hud.add(HotPotatoRSP, "game")

local function HotPotatoITRSP(v, player, cam)
	if gametype == GT_HOTPOTATO
		if player_rspbomb != false
		and player_rspbomb.valid
			v.drawString(160, 184, player_rspbomb.name.." is IT", V_OFFSET, "thin-center")
		end
	end
end
hud.add(HotPotatoITRSP, "scores")

addHook("MapLoad", function()
	player_rspbomb = false
	time_chooseit = 3*TICRATE
	showplayerit_text = 0
	killerqueentime = cv_explodeplayertimer.value*TICRATE
	snowplayerwin_text = 0
	rspit = nil
	warningcolor = false
	warningcolortime = 0
	for player in players.iterate do
		player.normalspeed = skins[player.skin].normalspeed
		player.actionspd = skins[player.skin].actionspd
	end
end)

addHook("NetVars", function(net)
	player_rspbomb = net($)
	time_chooseit = net($)
	showplayerit_text = net($)
	killerqueentime = net($)
	snowplayerwin_text = net($)
	rspit = net($)
	warningcolor = net($)
	warningcolortime = net($)
end)